package com.zhongzheng.controller.base;

import com.zhongzheng.common.annotation.Log;
import com.zhongzheng.common.core.controller.BaseController;
import com.zhongzheng.common.core.domain.AjaxResult;
import com.zhongzheng.common.core.domain.model.LoginUser;
import com.zhongzheng.common.core.page.TableDataInfo;
import com.zhongzheng.common.enums.BusinessType;
import com.zhongzheng.common.utils.ServletUtils;
import com.zhongzheng.framework.web.service.TokenService;
import com.zhongzheng.modules.base.bo.UserProfileEditBo;
import com.zhongzheng.modules.base.bo.UserProfileQueryBo;
import com.zhongzheng.modules.base.service.IUserProfileService;
import com.zhongzheng.modules.base.vo.UserProfileVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 填写资料审核Controller
 * 
 * @author ruoyi
 * @date 2021-12-20
 */
@Api(value = "填写盖章审核控制器", tags = {"填写盖章审核控制器"})
@RequiredArgsConstructor(onConstructor_ = @Autowired)
@RestController
@RequestMapping("/base/profileStamp")
public class UserProfileStampController extends BaseController {

    private final IUserProfileService iUserProfileService;

    private final TokenService tokenService;
    /**
     * 查询填写资料审核列表
     */
    @ApiOperation("查询填写盖章审核列表")
    @PreAuthorize("@ss.hasPermi('system:profile:list')")
    @GetMapping("/list")
    public TableDataInfo<UserProfileVo> list(UserProfileQueryBo bo) {
        startPage();
        //2为承诺书审核
        bo.setTypeStatus(2L);
        List<UserProfileVo> list = iUserProfileService.queryList(bo);
        return getDataTable(list);
    }

    /**
     * 查询填写资料审核列表
     */
    @ApiOperation("查询填写盖章审记录列表")
    @PreAuthorize("@ss.hasPermi('system:profile:list')")
    @GetMapping("/listRecord")
    public TableDataInfo<UserProfileVo> listRecord(UserProfileQueryBo bo) {
        startPage();
        bo.setTypeStatus(2L);
        List<UserProfileVo> list = iUserProfileService.listRecord(bo);
        return getDataTable(list);
    }

    /**
     * 获取填写资料审核详细信息
     */
    @ApiOperation("获取填写盖章审核详细信息")
    @PreAuthorize("@ss.hasPermi('system:profile:query')")
    @GetMapping("/{id}")
    public AjaxResult<UserProfileVo> getInfo(@PathVariable("id" ) Long id) {
        return AjaxResult.success(iUserProfileService.queryById(id));
    }

    /**
     * 修改填写资料审核
     */
    @ApiOperation("审核盖章")
    @PreAuthorize("@ss.hasPermi('system:profile:edit')")
    @Log(title = "填写盖章审核", businessType = BusinessType.UPDATE)
    @PostMapping()
    public AjaxResult<Void> edit(@RequestBody UserProfileEditBo bo) {
        LoginUser loginUser = tokenService.getLoginUser(ServletUtils.getRequest());
        return toAjax(iUserProfileService.updateAuditByEditBo(bo,loginUser) ? 1 : 0);
    }

}
